"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const sleep_1 = require("./sleep");
class ContractSendReceipt {
    constructor(rpc, sendResult) {
        this.rpc = rpc;
        Object.assign(this, sendResult);
    }
    /**
     * Check whether a transaction had been confirmed by n blocks.
     */
    async check(nblock = 3) {
        const tx = await this.rpc.getTransaction({ txid: this.txid });
        return tx.confirmations >= nblock;
    }
    /**
     * Repeatedly checks a transaction for confirmation.
     */
    async done(nblock = 3, timeout = 3000) {
        while (true) {
            const isConfirmed = await this.check(nblock);
            if (isConfirmed) {
                break;
            }
            await sleep_1.sleep(timeout);
        }
    }
}
exports.ContractSendReceipt = ContractSendReceipt;
