"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const QtumRPCRaw_1 = require("./QtumRPCRaw");
const sendToContractRequestDefaults = {
    amount: 0,
    gasLimit: 200000,
    // FIXME: Does not support string gasPrice although the doc says it does.
    gasPrice: 0.0000004,
};
class QtumRPC extends QtumRPCRaw_1.QtumRPCRaw {
    getInfo() {
        return this.rawCall("getinfo");
    }
    sendToContract(req) {
        const vals = Object.assign({}, sendToContractRequestDefaults, req);
        const args = [
            vals.address,
            vals.datahex,
            vals.amount,
            vals.gasLimit,
            vals.gasPrice,
        ];
        if (vals.senderAddress) {
            args.push(vals.senderAddress);
        }
        return this.rawCall("sendtocontract", ...args);
    }
    callContrct(req) {
        const args = [
            req.address,
            req.datahex,
        ];
        if (req.senderAddress) {
            args.push(req.senderAddress);
        }
        return this.rawCall("callcontract", ...args);
    }
    getTransaction(req) {
        const args = [
            req.txid,
        ];
        if (req.include_watchonly) {
            args.push(req.include_watchonly);
        }
        return this.rawCall("gettransaction", ...args);
    }
}
exports.QtumRPC = QtumRPC;
